#include "Motor.h"


Motor M1 (4,3);   // AnschlussPins des Motors (DIR, STEP) / hinten links, 0 = vorwärts
Motor M2 (7,6);   // AnschlussPins des Motors (DIR, STEP) / hinten rechts, 1 vorwärts
Motor M3 (9,8);   // AnschlussPins des Motors (DIR, STEP) / vorne links, 0 vorwärts
Motor M4 (12,11); // AnschlussPins des Motors (DIR, STEP) / vorne rechts, 1 vorwärts

const long stepsPerMeter = ???; // Anzahl Motorschritte für 1 Meter zurückgelegter Distanz (normal/vorwaerts)
const float a = 0,??; // horizontaler Abstand des Rad-Bodenpunktes von der Robotermitte rechts & links [m] 
const float b = 0,??; // vertikaler Abstand des Rad-Bodenpunktes von der Robotermitte oben & unten [m]

void setup() {
  
  // Serial.begin(115200); // Achtung, Aktivierung bremst das System !

}
  
void loop() {
  
  /*  
      Es wird eine Methode benoetigt, die prueft ob neue Fahranweisungen vom Kommunikationsmodul 
      vorliegen. -> Nach erfolgter Fahrt sollte diese nicht durch den loop-Teil erneut ausgefuehrt
      werden...
  */
  
  parameter();    // Initialisierung der aktuellen Fahrbefehle
  fahren();       // Anweisung "Fahren" an die einzelnen Motoren
  delayMicroseconds(10);
  
}

void parameter ((float strecke, float winkel, float drehwinkel) { 
  //eingehende Strecke in [m], rechtsdrehender Winkel der Strecke (Nullrichtung vorne), linksdrehender Drehwinkel (Omega)
  
  // Ber. der notwendigen Schritte in x & y Richtung
  float xSteps = stepsPerMeter * (strecke*cos(winkel));
  float ySteps = stepsPerMeter * (strecke*sin(winkel));
  float zeitfenster = ???;
  
  // Ber. der tatsaechlich zu machenden Schritte
  float stepsM1 = ySteps + xSteps + drehwinkel * (a+b);
  float stepsM2 = ySteps + xSteps - drehwinkel * (a+b);
  float stepsM3 = ySteps + xSteps - drehwinkel * (a+b);
  float stepsM4 = ySteps + xSteps + drehwinkel * (a+b);
  
  // Ber. der notwendigen MotorDrehRichtung
  int rotM1 = 0;
  int rotM2 = 0;
  int rotM3 = 0;
  int rotM4 = 0;
  
  // die richtigen umdrehungsrichtungen eintragen (konnte nicht mehr erfolgen)
  if(0 < winkel < 90){
  rotM1 = ; rotM2 =  ; rotM3 = ; rotM4 = ;}
  if(90 < winkel < 180){
  rotM1 = ; rotM2 = ; rotM3 = ; rotM4 = ;}
  if(180 < winkel < 270){
  rotM1 = ; rotM2 = ; rotM3 = ; rotM4 = ;}
  if(270 < winkel < 360){
  rotM1 = ; rotM2 = ; rotM3 = ; rotM4 = ;}
  
  // Uebergeben der Richtungen, Schritte, Zeitfenster an die MotorObjekte
  M1.startUp(rotM1, abs(stepsM1), zeitfenster);
  M2.startUp(rotM2, abs(stepsM2), zeitfenster);
  M3.startUp(rotM3, abs(stepsM3), zeitfenster);
  M4.startUp(rotM4, abs(stepsM4), zeitfenster); 

}

void fahren () {

   while( (M1.stepsToDo != M1.stepsDone) && (M2.stepsToDo != M2.stepsDone) && (M3.stepsToDo != M3.stepsDone) && (M4.stepsToDo != M4.stepsDone) ) {
     M1.makeSteps();
     M2.makeSteps();
     M3.makeSteps();
     M4.makeSteps();
  }
}
