/*  Motor.h - Library für Schrittmotoren.
    Created by Henry, 01.08.2014.
    Not Released.  */
 
#include "Arduino.h"

#ifndef Motor_h
#define Motor_h

class Motor {
  
  private:
  int dirPin;
  int stepPin;
  float currentMillis;
  float previousMillis;
  float intervall;
  float timeFrame;
    
  public:
  float stepsToDo;
  float stepsDone;
  Motor(int pinDIR, int pinSTEP);
  void startUp(int dir, float steps, float t);
  void set_Direction(int dir);
  void makeStep();
  void makeSteps();

};


#endif
